# Fuc.js
  Fintech UI Components
  
## Documentation

### Clone repository from [github](https://github.com/joy-web/fuc.js)

```git
git clone git@github.com:joy-web/fuc.js.git
cd fuc.js
npm install
```

### Initialize the development environment

At first, You need to install Jekyll. The Fuc.js docs is based on the [Jekyll](https://jekyllrb.com/).

Note: Jekyll is running in the ruby environment. You should exec the following command to install Ruby and Jekyll.

1. Make sure you have installed the latest version ruby. And we use the rvm to manage ruby.

  ```
    rvm install 2.4.2 # or the latest version for ruby
    gem update 
    # or 
    sudo gem update
  ```
  
2.  Install jekyll and dependency package.

Note: Make sure to install dependencies in the current directory('fuc.js').

```
gem install jekyll bundler
bundle install
# or
bundle update
```

###  Start Jekyll server

```npm
npm start
```

Then, You can open the serve in browser

http://localhost:9080/

You can refer to more information to http://jekyllrb.com/

## Build

```
npm run build
```

## Build jekyll doc

```
npm run jekyll:docs
```

## Publish to npm

```npm
npm publish
```

## Other Development

### Rouge Theme

Generate a highlighter rouge theme

```npm
npm run rouge-theme
```

Note: 
* The rouge themes has base16, base16.dark, base16.monokai, base16.monokai.light, base16.solarized, base16.solarized.dark,
  colorful, github, gruvbox, gruvbox.light, molokai, monokai, monokai.sublime, thankful_eyes, tulip
* After the rouge installed rouge (gem install rouge), you can use the command `rougify`
* Support highlighter language, you can view here http://rouge.jneen.net/
* the command `rougify -help style` can view all the support themes.
* You can search the theme from github https://github.com/search?q=pygments+style
* https://havee.me/internet/2016-02/upgrade-github-pages-site-to-jekyll-3.html

## Issue

https://github.com/joy-web/fuc.js/issues

## CHANGELOG

Please view [here](./CHANGELOG.md)

## JS Plugins 

* datatables
  * https://datatables.net/
* ztree
  http://www.treejs.cn/
* jquery-validate
  https://jqueryvalidation.org/
* velocity.js
  http://velocityjs.org/
* My97 DatePicker
  http://www.my97.net/
