import $ from 'jquery'

const loading = (($) => {

  const htmlStr = (loadingText) => {
    if (typeof loadingText === 'string') {
      return $(`
        <div class="fuc-loading-mask">
            <div class="fuc-loading-bg">
                <div class="fuc-loading-cont">
                  <span class="fuc-loading-img"></span>
                  <p>${loadingText}</p>
                </div>
            </div>
        </div>
      `);
    }
    return $(`
      <div class="fuc-loading-mask">
          <div class="fuc-loading-bg">
              <div class="fuc-loading-cont">
                <span class="fuc-loading-img"></span>
              </div>
          </div>
      </div>
    `);

  }

  const initLoading = function(me, status) {

    const loadingElement = htmlStr(status);

    // 如果没有传容器默认全局loading
    const ele = me ? me : $('body')

    if (status) {
      ele.append(loadingElement)

      // 如果是局部loading, 用绝对定位, 否则 fixed
      if (me) {
        loadingElement.css('position', 'absolute')
      }
    } else {
      ele.find('.fuc-loading-mask').css('position', 'fixed').remove()
    }
  }

  $.fn.loading = function (status) {
    initLoading(this, status)
    return this;
  }

  $.extend({
    loading(status) {
      initLoading(undefined, status)
      return this;
    }
  })

})($)


export default loading
